# DIETERpy is electricity market model developed by the research group
# Transformation of the Energy Economy at DIW Berlin (German Institute of Economic Research)
# copyright 2021, Carlos Gaete-Morales, Martin Kittel, Alexander Roth,
# Wolf-Peter Schill, Alexander Zerrahn
"""
This module is the core of DIETERpy. It contains all functions to process the input data, the GAMS API to run and solve an optimization problem, and the functions that handle the resulting GDX files generated by GAMS. 
"""
from . import gdx_handler
from . import input_data
from . import output_data
from . import solve
from . import runopt
from . import report
